#include "verifier.h"
#include "crypto_uint8.h"

int main()
{
  crypto_int32 a0;
  crypto_int32 a1;
  crypto_int32 b0;
  crypto_int32 b1;
  crypto_uint8 c;
  a0.inputint();
  a1.inputint();
  b0.inputint();
  b1.inputint();
  c.inputint();
  c &= 1;
  verifier_bigint A;
  verifier_addlimb(&A,a0,0);
  verifier_addlimb(&A,a1,26);
  verifier_bigint B;
  verifier_addlimb(&B,b0,0);
  verifier_addlimb(&B,b1,26);
  crypto_int32 mask = -(crypto_int32) c;
  crypto_int32 x0 = a0 ^ ((a0 ^ b0) & mask);
  crypto_int32 x1 = a1 ^ ((a1 ^ b1) & mask);
  crypto_int32 y0 = b0 ^ ((a0 ^ b0) & mask);
  crypto_int32 y1 = b1 ^ ((a1 ^ b1) & mask);
  verifier_bigint X;
  verifier_addlimb(&X,x0,0);
  verifier_addlimb(&X,x1,26);
  verifier_bigint Y;
  verifier_addlimb(&Y,y0,0);
  verifier_addlimb(&Y,y1,26);
  verifier_assertcmov(&X,&A,&B,c);
  verifier_assertcswap(&X,&Y,&A,&B,c);
  return 0;
}
