#include "crypto_uint8.h"
#include "crypto_int32.h"
#include "verifier.h"
#include "fe.h"

int main()
{
  crypto_uint8 s[32];

  for (int i = 0;i < 32;++i) s[i].inputunsignedchar();

  verifier_bigint vs;
  for (int i = 0;i < 32;++i) verifier_addlimb(&vs,s[i],i * 8);

  for (int i = 0;i < 256;++i) {
    crypto_uint8 b = (s[i / 8] >> (i & 7)) & 1;
    verifier_assertbit(b,&vs,i);
  }

  return 0;
}
