#include "crypto_int32.h"
#include "verifier.h"
#include "fe.h"

main()
{
  crypto_int32 f[10];
  crypto_int32 g[10];
  crypto_int32 h[10];

  f[0].inputint();
  f[1].inputint();
  f[2].inputint();
  f[3].inputint();
  f[4].inputint();
  f[5].inputint();
  f[6].inputint();
  f[7].inputint();
  f[8].inputint();
  f[9].inputint();
  g[0].inputint();
  g[1].inputint();
  g[2].inputint();
  g[3].inputint();
  g[4].inputint();
  g[5].inputint();
  g[6].inputint();
  g[7].inputint();
  g[8].inputint();
  g[9].inputint();

  verifier_assumerange(f[0],"-36909875","36909875");
  verifier_assumerange(f[1],"-18454937","18454937");
  verifier_assumerange(f[2],"-36909875","36909875");
  verifier_assumerange(f[3],"-18454937","18454937");
  verifier_assumerange(f[4],"-36909875","36909875");
  verifier_assumerange(f[5],"-18454937","18454937");
  verifier_assumerange(f[6],"-36909875","36909875");
  verifier_assumerange(f[7],"-18454937","18454937");
  verifier_assumerange(f[8],"-36909875","36909875");
  verifier_assumerange(f[9],"-18454937","18454937");
  verifier_assumerange(g[0],"-36909875","36909875");
  verifier_assumerange(g[1],"-18454937","18454937");
  verifier_assumerange(g[2],"-36909875","36909875");
  verifier_assumerange(g[3],"-18454937","18454937");
  verifier_assumerange(g[4],"-36909875","36909875");
  verifier_assumerange(g[5],"-18454937","18454937");
  verifier_assumerange(g[6],"-36909875","36909875");
  verifier_assumerange(g[7],"-18454937","18454937");
  verifier_assumerange(g[8],"-36909875","36909875");
  verifier_assumerange(g[9],"-18454937","18454937");

  verifier_bigint vf;
  verifier_limbs_10_255(&vf,f);
  verifier_bigint vg;
  verifier_limbs_10_255(&vg,g);

  fe_sub(h,f,g);

  verifier_bigint vh;
  verifier_limbs_10_255(&vh,h);
  verifier_assertdiff(&vh,&vf,&vg);

  verifier_assertrange(h[0],"-73819750","73819750");
  verifier_assertrange(h[2],"-73819750","73819750");
  verifier_assertrange(h[4],"-73819750","73819750");
  verifier_assertrange(h[6],"-73819750","73819750");
  verifier_assertrange(h[8],"-73819750","73819750");
  verifier_assumerange(h[1],"-36909875","36909875");
  verifier_assumerange(h[3],"-36909875","36909875");
  verifier_assumerange(h[5],"-36909875","36909875");
  verifier_assumerange(h[7],"-36909875","36909875");
  verifier_assumerange(h[9],"-36909875","36909875");
}
